Code

change quoting in test t1006-cat-file.sh
[git.git] / git-clone.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005, Linus Torvalds
4 # Copyright (c) 2005, Junio C Hamano
5 #
6 # Clone a repository into a different directory that does not yet exist.
8 # See git-sh-setup why.
9 unset CDPATH
11 OPTIONS_SPEC="\
12 git-clone [options] [--] <repo> [<dir>]
13 --
14 n,no-checkout        don't create a checkout
15 bare                 create a bare repository
16 naked                create a bare repository
17 l,local              to clone from a local repository
18 no-hardlinks         don't use local hardlinks, always copy
19 s,shared             setup as a shared repository
20 template=            path to the template directory
21 q,quiet              be quiet
22 reference=           reference repository
23 o,origin=            use <name> instead of 'origin' to track upstream
24 u,upload-pack=       path to git-upload-pack on the remote
25 depth=               create a shallow clone of that depth
27 use-separate-remote  compatibility, do not use
28 no-separate-remote   compatibility, do not use"
30 die() {
31         echo >&2 "$@"
32         exit 1
33 }
35 usage() {
36         exec "$0" -h
37 }
39 eval "$(echo "$OPTIONS_SPEC" | git rev-parse --parseopt -- "$@" || echo exit $?)"
41 get_repo_base() {
42         (
43                 cd "`/bin/pwd`" &&
44                 cd "$1" || cd "$1.git" &&
45                 {
46                         cd .git
47                         pwd
48                 }
49         ) 2>/dev/null
50 }
52 if [ -n "$GIT_SSL_NO_VERIFY" -o \
53         "`git config --bool http.sslVerify`" = false ]; then
54     curl_extra_args="-k"
55 fi
57 http_fetch () {
58         # $1 = Remote, $2 = Local
59         curl -nsfL $curl_extra_args "$1" >"$2"
60         curl_exit_status=$?
61         case $curl_exit_status in
62         126|127) exit ;;
63         *)       return $curl_exit_status ;;
64         esac
65 }
67 clone_dumb_http () {
68         # $1 - remote, $2 - local
69         cd "$2" &&
70         clone_tmp="$GIT_DIR/clone-tmp" &&
71         mkdir -p "$clone_tmp" || exit 1
72         if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
73                 "`git config --bool http.noEPSV`" = true ]; then
74                 curl_extra_args="${curl_extra_args} --disable-epsv"
75         fi
76         http_fetch "$1/info/refs" "$clone_tmp/refs" ||
77                 die "Cannot get remote repository information.
78 Perhaps git-update-server-info needs to be run there?"
79         test "z$quiet" = z && v=-v || v=
80         while read sha1 refname
81         do
82                 name=`expr "z$refname" : 'zrefs/\(.*\)'` &&
83                 case "$name" in
84                 *^*)    continue;;
85                 esac
86                 case "$bare,$name" in
87                 yes,* | ,heads/* | ,tags/*) ;;
88                 *)      continue ;;
89                 esac
90                 if test -n "$use_separate_remote" &&
91                    branch_name=`expr "z$name" : 'zheads/\(.*\)'`
92                 then
93                         tname="remotes/$origin/$branch_name"
94                 else
95                         tname=$name
96                 fi
97                 git-http-fetch $v -a -w "$tname" "$sha1" "$1" || exit 1
98         done <"$clone_tmp/refs"
99         rm -fr "$clone_tmp"
100         http_fetch "$1/HEAD" "$GIT_DIR/REMOTE_HEAD" ||
101         rm -f "$GIT_DIR/REMOTE_HEAD"
102         if test -f "$GIT_DIR/REMOTE_HEAD"; then
103                 head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
104                 case "$head_sha1" in
105                 'ref: refs/'*)
106                         ;;
107                 *)
108                         git-http-fetch $v -a "$head_sha1" "$1" ||
109                         rm -f "$GIT_DIR/REMOTE_HEAD"
110                         ;;
111                 esac
112         fi
115 quiet=
116 local=no
117 use_local_hardlink=yes
118 local_shared=no
119 unset template
120 no_checkout=
121 upload_pack=
122 bare=
123 reference=
124 origin=
125 origin_override=
126 use_separate_remote=t
127 depth=
128 no_progress=
129 local_explicitly_asked_for=
130 test -t 1 || no_progress=--no-progress
132 while test $# != 0
133 do
134         case "$1" in
135         -n|--no-checkout)
136                 no_checkout=yes ;;
137         --naked|--bare)
138                 bare=yes ;;
139         -l|--local)
140                 local_explicitly_asked_for=yes
141                 use_local_hardlink=yes
142                 ;;
143         --no-hardlinks)
144                 use_local_hardlink=no ;;
145         -s|--shared)
146                 local_shared=yes ;;
147         --template)
148                 shift; template="--template=$1" ;;
149         -q|--quiet)
150                 quiet=-q ;;
151         --use-separate-remote|--no-separate-remote)
152                 die "clones are always made with separate-remote layout" ;;
153         --reference)
154                 shift; reference="$1" ;;
155         -o|--origin)
156                 shift;
157                 case "$1" in
158                 '')
159                     usage ;;
160                 */*)
161                     die "'$1' is not suitable for an origin name"
162                 esac
163                 git check-ref-format "heads/$1" ||
164                     die "'$1' is not suitable for a branch name"
165                 test -z "$origin_override" ||
166                     die "Do not give more than one --origin options."
167                 origin_override=yes
168                 origin="$1"
169                 ;;
170         -u|--upload-pack)
171                 shift
172                 upload_pack="--upload-pack=$1" ;;
173         --depth)
174                 shift
175                 depth="--depth=$1" ;;
176         --)
177                 shift
178                 break ;;
179         *)
180                 usage ;;
181         esac
182         shift
183 done
185 repo="$1"
186 test -n "$repo" ||
187     die 'you must specify a repository to clone.'
189 # --bare implies --no-checkout and --no-separate-remote
190 if test yes = "$bare"
191 then
192         if test yes = "$origin_override"
193         then
194                 die '--bare and --origin $origin options are incompatible.'
195         fi
196         no_checkout=yes
197         use_separate_remote=
198 fi
200 if test -z "$origin"
201 then
202         origin=origin
203 fi
205 # Turn the source into an absolute path if
206 # it is local
207 if base=$(get_repo_base "$repo"); then
208         repo="$base"
209         if test -z "$depth"
210         then
211                 local=yes
212         fi
213 elif test -f "$repo"
214 then
215         case "$repo" in /*) ;; *) repo="$PWD/$repo" ;; esac
216 fi
218 # Decide the directory name of the new repository
219 if test -n "$2"
220 then
221         dir="$2"
222         test $# = 2 || die "excess parameter to git-clone"
223 else
224         # Derive one from the repository name
225         # Try using "humanish" part of source repo if user didn't specify one
226         if test -f "$repo"
227         then
228                 # Cloning from a bundle
229                 dir=$(echo "$repo" | sed -e 's|/*\.bundle$||' -e 's|.*/||g')
230         else
231                 dir=$(echo "$repo" |
232                         sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
233         fi
234 fi
236 [ -e "$dir" ] && die "destination directory '$dir' already exists."
237 [ yes = "$bare" ] && unset GIT_WORK_TREE
238 [ -n "$GIT_WORK_TREE" ] && [ -e "$GIT_WORK_TREE" ] &&
239 die "working tree '$GIT_WORK_TREE' already exists."
240 D=
241 W=
242 cleanup() {
243         err=$?
244         test -z "$D" && rm -rf "$dir"
245         test -z "$W" && test -n "$GIT_WORK_TREE" && rm -rf "$GIT_WORK_TREE"
246         cd ..
247         test -n "$D" && rm -rf "$D"
248         test -n "$W" && rm -rf "$W"
249         exit $err
251 trap cleanup 0
252 mkdir -p "$dir" && D=$(cd "$dir" && pwd) || usage
253 test -n "$GIT_WORK_TREE" && mkdir -p "$GIT_WORK_TREE" &&
254 W=$(cd "$GIT_WORK_TREE" && pwd) && GIT_WORK_TREE="$W" && export GIT_WORK_TREE
255 if test yes = "$bare" || test -n "$GIT_WORK_TREE"; then
256         GIT_DIR="$D"
257 else
258         GIT_DIR="$D/.git"
259 fi &&
260 export GIT_DIR &&
261 GIT_CONFIG="$GIT_DIR/config" git-init $quiet ${template+"$template"} || usage
263 if test -n "$bare"
264 then
265         GIT_CONFIG="$GIT_DIR/config" git config core.bare true
266 fi
268 if test -n "$reference"
269 then
270         ref_git=
271         if test -d "$reference"
272         then
273                 if test -d "$reference/.git/objects"
274                 then
275                         ref_git="$reference/.git"
276                 elif test -d "$reference/objects"
277                 then
278                         ref_git="$reference"
279                 fi
280         fi
281         if test -n "$ref_git"
282         then
283                 ref_git=$(cd "$ref_git" && pwd)
284                 echo "$ref_git/objects" >"$GIT_DIR/objects/info/alternates"
285                 (
286                         GIT_DIR="$ref_git" git for-each-ref \
287                                 --format='%(objectname) %(*objectname)'
288                 ) |
289                 while read a b
290                 do
291                         test -z "$a" ||
292                         git update-ref "refs/reference-tmp/$a" "$a"
293                         test -z "$b" ||
294                         git update-ref "refs/reference-tmp/$b" "$b"
295                 done
296         else
297                 die "reference repository '$reference' is not a local directory."
298         fi
299 fi
301 rm -f "$GIT_DIR/CLONE_HEAD"
303 # We do local magic only when the user tells us to.
304 case "$local" in
305 yes)
306         ( cd "$repo/objects" ) ||
307                 die "cannot chdir to local '$repo/objects'."
309         if test "$local_shared" = yes
310         then
311                 mkdir -p "$GIT_DIR/objects/info"
312                 echo "$repo/objects" >>"$GIT_DIR/objects/info/alternates"
313         else
314                 cpio_quiet_flag=""
315                 cpio --help 2>&1 | grep -- --quiet >/dev/null && \
316                         cpio_quiet_flag=--quiet
317                 l= &&
318                 if test "$use_local_hardlink" = yes
319                 then
320                         # See if we can hardlink and drop "l" if not.
321                         sample_file=$(cd "$repo" && \
322                                       find objects -type f -print | sed -e 1q)
323                         # objects directory should not be empty because
324                         # we are cloning!
325                         test -f "$repo/$sample_file" ||
326                                 die "fatal: cannot clone empty repository"
327                         if ln "$repo/$sample_file" "$GIT_DIR/objects/sample" 2>/dev/null
328                         then
329                                 rm -f "$GIT_DIR/objects/sample"
330                                 l=l
331                         elif test -n "$local_explicitly_asked_for"
332                         then
333                                 echo >&2 "Warning: -l asked but cannot hardlink to $repo"
334                         fi
335                 fi &&
336                 cd "$repo" &&
337                 find objects -depth -print | cpio $cpio_quiet_flag -pumd$l "$GIT_DIR/" || \
338                         exit 1
339         fi
340         git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
341         ;;
342 *)
343         case "$repo" in
344         rsync://*)
345                 case "$depth" in
346                 "") ;;
347                 *) die "shallow over rsync not supported" ;;
348                 esac
349                 rsync $quiet -av --ignore-existing  \
350                         --exclude info "$repo/objects/" "$GIT_DIR/objects/" ||
351                 exit
352                 # Look at objects/info/alternates for rsync -- http will
353                 # support it natively and git native ones will do it on the
354                 # remote end.  Not having that file is not a crime.
355                 rsync -q "$repo/objects/info/alternates" \
356                         "$GIT_DIR/TMP_ALT" 2>/dev/null ||
357                         rm -f "$GIT_DIR/TMP_ALT"
358                 if test -f "$GIT_DIR/TMP_ALT"
359                 then
360                     ( cd "$D" &&
361                       . git-parse-remote &&
362                       resolve_alternates "$repo" <"$GIT_DIR/TMP_ALT" ) |
363                     while read alt
364                     do
365                         case "$alt" in 'bad alternate: '*) die "$alt";; esac
366                         case "$quiet" in
367                         '')     echo >&2 "Getting alternate: $alt" ;;
368                         esac
369                         rsync $quiet -av --ignore-existing  \
370                             --exclude info "$alt" "$GIT_DIR/objects" || exit
371                     done
372                     rm -f "$GIT_DIR/TMP_ALT"
373                 fi
374                 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD" || exit 1
375                 ;;
376         https://*|http://*|ftp://*)
377                 case "$depth" in
378                 "") ;;
379                 *) die "shallow over http or ftp not supported" ;;
380                 esac
381                 if test -z "@@NO_CURL@@"
382                 then
383                         clone_dumb_http "$repo" "$D"
384                 else
385                         die "http transport not supported, rebuild Git with curl support"
386                 fi
387                 ;;
388         *)
389                 if [ -f "$repo" ] ; then
390                         git bundle unbundle "$repo" > "$GIT_DIR/CLONE_HEAD" ||
391                         die "unbundle from '$repo' failed."
392                 else
393                         case "$upload_pack" in
394                         '') git-fetch-pack --all -k $quiet $depth $no_progress "$repo";;
395                         *) git-fetch-pack --all -k \
396                                 $quiet "$upload_pack" $depth $no_progress "$repo" ;;
397                         esac >"$GIT_DIR/CLONE_HEAD" ||
398                         die "fetch-pack from '$repo' failed."
399                 fi
400                 ;;
401         esac
402         ;;
403 esac
404 test -d "$GIT_DIR/refs/reference-tmp" && rm -fr "$GIT_DIR/refs/reference-tmp"
406 if test -f "$GIT_DIR/CLONE_HEAD"
407 then
408         # Read git-fetch-pack -k output and store the remote branches.
409         if [ -n "$use_separate_remote" ]
410         then
411                 branch_top="remotes/$origin"
412         else
413                 branch_top="heads"
414         fi
415         tag_top="tags"
416         while read sha1 name
417         do
418                 case "$name" in
419                 *'^{}')
420                         continue ;;
421                 HEAD)
422                         destname="REMOTE_HEAD" ;;
423                 refs/heads/*)
424                         destname="refs/$branch_top/${name#refs/heads/}" ;;
425                 refs/tags/*)
426                         destname="refs/$tag_top/${name#refs/tags/}" ;;
427                 *)
428                         continue ;;
429                 esac
430                 git update-ref -m "clone: from $repo" "$destname" "$sha1" ""
431         done < "$GIT_DIR/CLONE_HEAD"
432 fi
434 if test -n "$W"; then
435         cd "$W" || exit
436 else
437         cd "$D" || exit
438 fi
440 if test -z "$bare"
441 then
442         # a non-bare repository is always in separate-remote layout
443         remote_top="refs/remotes/$origin"
444         head_sha1=
445         test ! -r "$GIT_DIR/REMOTE_HEAD" || head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
446         case "$head_sha1" in
447         'ref: refs/'*)
448                 # Uh-oh, the remote told us (http transport done against
449                 # new style repository with a symref HEAD).
450                 # Ideally we should skip the guesswork but for now
451                 # opt for minimum change.
452                 head_sha1=`expr "z$head_sha1" : 'zref: refs/heads/\(.*\)'`
453                 head_sha1=`cat "$GIT_DIR/$remote_top/$head_sha1"`
454                 ;;
455         esac
457         # The name under $remote_top the remote HEAD seems to point at.
458         head_points_at=$(
459                 (
460                         test -f "$GIT_DIR/$remote_top/master" && echo "master"
461                         cd "$GIT_DIR/$remote_top" &&
462                         find . -type f -print | sed -e 's/^\.\///'
463                 ) | (
464                 done=f
465                 while read name
466                 do
467                         test t = $done && continue
468                         branch_tip=`cat "$GIT_DIR/$remote_top/$name"`
469                         if test "$head_sha1" = "$branch_tip"
470                         then
471                                 echo "$name"
472                                 done=t
473                         fi
474                 done
475                 )
476         )
478         # Upstream URL
479         git config remote."$origin".url "$repo" &&
481         # Set up the mappings to track the remote branches.
482         git config remote."$origin".fetch \
483                 "+refs/heads/*:$remote_top/*" '^$' &&
485         # Write out remote.$origin config, and update our "$head_points_at".
486         case "$head_points_at" in
487         ?*)
488                 # Local default branch
489                 git symbolic-ref HEAD "refs/heads/$head_points_at" &&
491                 # Tracking branch for the primary branch at the remote.
492                 git update-ref HEAD "$head_sha1" &&
494                 rm -f "refs/remotes/$origin/HEAD"
495                 git symbolic-ref "refs/remotes/$origin/HEAD" \
496                         "refs/remotes/$origin/$head_points_at" &&
498                 git config branch."$head_points_at".remote "$origin" &&
499                 git config branch."$head_points_at".merge "refs/heads/$head_points_at"
500                 ;;
501         '')
502                 if test -z "$head_sha1"
503                 then
504                         # Source had nonexistent ref in HEAD
505                         echo >&2 "Warning: Remote HEAD refers to nonexistent ref, unable to checkout."
506                         no_checkout=t
507                 else
508                         # Source had detached HEAD pointing nowhere
509                         git update-ref --no-deref HEAD "$head_sha1" &&
510                         rm -f "refs/remotes/$origin/HEAD"
511                 fi
512                 ;;
513         esac
515         case "$no_checkout" in
516         '')
517                 test "z$quiet" = z -a "z$no_progress" = z && v=-v || v=
518                 git read-tree -m -u $v HEAD HEAD
519         esac
520 fi
521 rm -f "$GIT_DIR/CLONE_HEAD" "$GIT_DIR/REMOTE_HEAD"
523 trap - 0